
var ILOpt = {
  nsIImgLikeOpera: Components.classes["@mozilla.org/imglikeopera;1"]
                             .getService(Components.interfaces.nsIImgLikeOpera)
                             .wrappedJSObject,
  
  get strBundleManager() {
    delete this.strBundleManager;
    return this.strBundleManager = this.nsIImgLikeOpera.strBundleManager;
  },
  
  get settings() {
    return this.nsIImgLikeOpera.settings;
  },
  
  onLoad: function() {
    window.removeEventListener("load", this.onLoad, false);
    
    var settings = this.settings;
    
    /** experimentalOptions [start] **/
    
    this.secretTab = document.getElementById("iloTabForExpOptions");
    this.secretTabParentNode = this.secretTab.parentNode;
    
    document.getElementById("checkbox-flash-block").setAttribute("checked", settings.flashBlock);
    if (settings.loadLinkedImages) {
      document.getElementById("checkbox-linked-images").setAttribute("checked", true);
      document.getElementById("checkbox-linked-images-orig-site").setAttribute("disabled", false);
      document.getElementById("checkbox-linked-images-orig-site")
              .setAttribute("checked", settings.loadLinkedImages == 2 ? true : false);
    }
    
    document.getElementById("textbox-delay-load").setAttribute("value", settings.delayLoad);
    
    var checkboxExperimentalOptions = document.getElementById("checkbox-experimental-options");
    checkboxExperimentalOptions.addEventListener("CheckboxStateChange", this.displayExperimentalTab, false);
    checkboxExperimentalOptions.checked = settings.experimentalOptions;
    
    /** experimentalOptions [end] **/
    
    var menuDefaultPolicy = document.getElementById("menu-default-policy");
    menuDefaultPolicy.selectedIndex = settings.defaultPolicy ?
                                          4 - settings.defaultPolicy : 9 - settings.startupPolicy;
    
    var checkboxExpirationTime = document.getElementById("checkbox-expiration-time");
    var menuExpirationTime = document.getElementById("menu-expiration-time");
    if (settings.expirationTime > 0) {
      checkboxExpirationTime.setAttribute("checked", true);
      menuExpirationTime.setAttribute("disabled", false);
      var menuExpirationTimeNodes = menuExpirationTime.childNodes[0].childNodes;
      var menuExpirationTimeNodesCount = menuExpirationTimeNodes.length;
      
      for (i=0; i<menuExpirationTimeNodesCount; i++)
        if (menuExpirationTimeNodes[i].value == settings.expirationTime)
          menuExpirationTime.selectedIndex = i;
    }
    
    var checkboxTabsRefresh = document.getElementById("checkbox-tabs-refresh");
    checkboxTabsRefresh.setAttribute("checked", settings.tabsRefresh);
    
    var checkboxEscKey = document.getElementById("checkbox-esc-stop-load");
    checkboxEscKey.setAttribute("checked", settings.escKey);
    
    this.rAddFilter = document.getElementById("iloAddFilter");
    this.rAddPolicy = document.getElementById("iloAddPolicy");
    this.rTree =      document.getElementById("iloPermissionsTree");
    this.rTreeCh =    document.getElementById("iloPermissionsTreeChildren");
    this.rButtons =   document.getElementById("iloPermButtons").childNodes;
    this.rPopup =     document.getElementById("iloFiltersPopup").childNodes;
    
    if (settings.policyPatterns.split) {
      var tmp = settings.policyPatterns.split("  ");
      var tmpCount = tmp.length-1;
      for (var i=0; i<tmpCount; i++)
        this.treeAddItem(tmp[i].split(" "));
    }
    
    const fontEnumerator = Components.classes["@mozilla.org/gfx/fontenumerator;1"]
                                     .createInstance()
                                     .QueryInterface(Components.interfaces.nsIFontEnumerator);
    
    var allFonts = fontEnumerator.EnumerateAllFonts({value:0});
    
    var [fontFamily, fontSize] = this.nsIImgLikeOpera.userCssFontData;
    
    var fontMenu = document.getElementById("menu-placeholders-font");
    for (i = 0; i < allFonts.length; i++) {
      fontMenu.appendItem(allFonts[i], allFonts[i]);
      if (allFonts[i] == fontFamily)
        fontMenu.selectedIndex = i+1;
    }
    
    var sizeMenu = document.getElementById("menu-placeholders-fontsize");
    var sizeMenuNodes = sizeMenu.childNodes[0].childNodes;
    
    for (i=0; i<sizeMenuNodes.length; i++)
      if (sizeMenuNodes[i].value == fontSize)
        sizeMenu.selectedIndex = i;
  
  },//~ </onLoad>
  
  saveSettings: function() {
    var fontFamily = document.getElementById("menu-placeholders-font").selectedItem.getAttribute("value") || "";
    var fontSize = document.getElementById("menu-placeholders-fontsize").selectedItem.getAttribute("value") || "";

    this.nsIImgLikeOpera.userCssFontData = [fontFamily, fontSize];

    var startupPolicy = 3, defaultPolicy = 4 - document.getElementById("menu-default-policy").selectedIndex;
    if (defaultPolicy < 0) {
      startupPolicy = 5 + defaultPolicy;
      defaultPolicy = 0;
    }
    
    var settings = this.settings;
    
    settings.defaultPolicy = defaultPolicy;
    settings.startupPolicy = startupPolicy;
    
    settings.expirationTime =
        (document.getElementById("checkbox-expiration-time").checked) ?
        document.getElementById("menu-expiration-time").selectedItem.value : 0;
    
    settings.tabsRefresh = document.getElementById("checkbox-tabs-refresh").checked;
    settings.escKey = document.getElementById("checkbox-esc-stop-load").checked;
    settings.experimentalOptions = document.getElementById("checkbox-experimental-options").checked;
    settings.policyPatterns = this.treeMakePattern();
    
    if (document.getElementById("iloTabForExpOptions")) {
      settings.flashBlock = document.getElementById("checkbox-flash-block").checked;
      
      settings.loadLinkedImages =
          document.getElementById("checkbox-linked-images-orig-site").checked ?
                    2 :
                    document.getElementById("checkbox-linked-images").checked ?
                    1 : 0;
      
      settings.delayLoad = document.getElementById("textbox-delay-load").value;
    }
    
    window.close();
  },
  
  displayExperimentalTab: function(e) {
    e.target.checked ? ILOpt.secretTabParentNode.appendChild(ILOpt.secretTab) : ILOpt.secretTabParentNode.removeChild(ILOpt.secretTab);
  },
  
  //~ Fill filters tree.
  fillFiltersList: function (patterns, overwriteCurrentList) {
    if (overwriteCurrentList)
      this.removeFilter("all");
    
    var patt;
    for (var i = 0; i < patterns.length; i++) {
      patt = patterns[i].split(" ");
      patt[1] = patt[1][0];
      if (patt.length == 2 && patt[1]>0 && patt[1]<5)
        this.treeAddItem(patt);
    }
  },
  
  //~ Imports filters from disc.
  filtersImportList: function() {
    var fp =       Components.classes["@mozilla.org/filepicker;1"]
                             .createInstance(Components.interfaces.nsIFilePicker);
    var stream =   Components.classes["@mozilla.org/network/file-input-stream;1"]
                             .createInstance(Components.interfaces.nsIFileInputStream);
    var streamIO = Components.classes["@mozilla.org/scriptableinputstream;1"]
                             .createInstance(Components.interfaces.nsIScriptableInputStream);
    
    var overwriteCurrentList = false, input, inputArray, validFile = false;
    
    fp.init(window, this.strBundleManager.getString("importexportFilters"), fp.modeOpen);
    fp.appendFilters(fp.filterText);
    
    if (fp.show() != fp.returnCancel) {
      stream.init(fp.file, 0x01, 0444, null);
      streamIO.init(stream);
      input = streamIO.read(stream.available());
      streamIO.close();
      stream.close();
      
      //~ unix + mac + dos environment-compatible
      //~ first: whole match -- second: backref-1 -- etc..
      linebreak = input.match(/(?:\[ImgLikeOpera\])(((\n+)|(\r+))+)/m)[1];
      
      inputArray = input.split(linebreak);
      
      var headerRe = /\[ImgLikeOpera\]/; //~ tests if the first line is ILO's header
      if (headerRe.test(inputArray[0])) {
        inputArray.shift();
        overwriteCurrentList = confirm(this.strBundleManager.getString("overwriteCurrentListConfirm"));
        this.fillFiltersList(inputArray, overwriteCurrentList);
      }
      else
        alert(this.strBundleManager.getString("fileNotValid"));
    }
  },
  
  //~ Exports the current list of filters to a file on disc.
  filtersExportList: function() {
    var fp     = Components.classes["@mozilla.org/filepicker;1"]
                           .createInstance(Components.interfaces.nsIFilePicker);
    var stream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                           .createInstance(Components.interfaces.nsIFileOutputStream);
    
    fp.init(window, this.strBundleManager.getString("importexportFilters"), fp.modeSave);
    fp.appendFilters(fp.filterText);
    
    if (fp.show() != fp.returnCancel) {
      if (fp.file.exists())
        fp.file.remove(true);
      
      fp.file.create(fp.file.NORMAL_FILE_TYPE, 0755);
      
      stream.init(fp.file, 0x02, 0x200, null);
      stream.write("[ImgLikeOpera]\n", 15);
      
      patterns = this.treeMakePattern().split("  ");
      
      for (var i=0; i<patterns.length-1; i++)
        stream.write(patterns[i]+"\n", patterns[i].length+1);
      
      stream.close();
    }
  },
  
  checkEvent: function(e) {
    if (e == "quit")
      window.close();
    
    if (e == "linkedImages") {
      var origSiteCheckbox = document.getElementById('checkbox-linked-images-orig-site');
      if (document.getElementById('checkbox-linked-images').checked) {
        origSiteCheckbox.setAttribute("disabled", true);
        origSiteCheckbox.setAttribute("checked", false);
      } else {
        origSiteCheckbox.setAttribute("disabled", false);
      }
      return;
    }
    
    if (document.getElementById("iloSettingsTab2").parentNode.selectedIndex != 1)
      return;
    
    if (e == "copy") {
      var rowText = this.getRowData();
      if (!rowText) return;
      
      this.rAddFilter.value = rowText[0];
      this.rAddPolicy.selectedIndex = 4 - rowText[1];
      
      return;
    }
    
    if (e == "modify") {
      var rowText = this.getRowData();
      if (!rowText) return;
      
      var rv = { rv: null };
      
      openDialog("chrome://imglikeopera/content/optionsdialog.xul",
                 "_blank", "chrome,dependent,modal", rowText, rv);
      
      if (rv.rv) {
        this.removeFilter();
        rowText[2] -= -1;
        this.treeAddItem(rv.rv, rowText[2]);
      }
      
      return;
    }
    
    if (e == "selectAll")
      return this.rTree.view.selection.selectAll();
    
    if (e == "removeFilters") {
      if (this.rButtons[4].disabled) return;
      
      if (confirm(this.strBundleManager.getString("removeSelectedFilters")+"?"))
        this.removeFilter();
      
      return;
    }
    
    if (e == "removeAllFilters") {
      if (this.rButtons[5].disabled) return;
      
      if (confirm(this.strBundleManager.getString("removeAllFilters")+"?"))
        this.removeFilter("all");
      
      return;
    }
    
    if (e == "removeAllFilters") {
    }
    
    var i = (e == "top" || e == "up") ? 0 : 2;
    if (this.rButtons[i].getAttribute("disabled") == "true")
      return;
    
    this.filterSetPriority(e);
  },
  
  treeAddItem: function (items, indx) {
    var tri = document.createElement("treeitem");
    var trr = document.createElement("treerow");
    var trc1 = document.createElement("treecell");
    var trc2 = document.createElement("treecell");
    var trc3 = document.createElement("treecell");
    
    //~ RegExp test
    var txt = items[0].replace(/[\s]*/g, "");
    if (txt[0] == "/" && txt[2]) {
      var mod = "";
      var txtEnd = txt.substr(txt.length-2, txt.length);
      
      if (txtEnd == "/i" || txtEnd == "/I") { mod = "i"; var res = txt.substr(1, txt.length-3); }
      else if (txtEnd[1] == "/") { var res = txt.substr(1, txt.length-2); }
      
      try { var reg = new RegExp(res, mod); } catch(e){}
      
      if (reg)
        trc1.setAttribute("label", "R");
    }
    
    trc2.setAttribute("label", txt);
    trc3.setAttribute("label", items[1]);
    trr.appendChild(trc1);
    trr.appendChild(trc2);
    trr.appendChild(trc3);
    tri.appendChild(trr);
    
    if (!indx)
      return this.rTreeCh.appendChild(tri);
    
    indx--;
    this.rTreeCh.insertBefore(tri, this.rTreeCh.childNodes[indx]);
    this.rTree.view.selection.select(indx);
  },
  
  treeMakePattern: function() {
    var pattern = '', item;
    var iCount = this.rTreeCh.childNodes.length;
    for (var i = 0; i < iCount; i++) {
      item = this.rTreeCh.childNodes[i].childNodes[0];
      pattern += item.childNodes[1].getAttribute("label") +
                   " " + item.childNodes[2].getAttribute("label") + "  ";
    }
    return pattern;
  },
  
  getTreeSelections: function() {
    var selections = [];
    var select = this.rTree.view.selection;
    if (select) {
      var count = select.getRangeCount();
      var min = new Object();
      var max = new Object();
      for (var i=0; i<count; i++) {
        select.getRangeAt(i, min, max);
        for (var k=min.value; k<=max.value; k++)
          if (k != -1) selections[selections.length] = k;
      }
    }
    return selections;
  },

  buttonsDisabled: function(status) {
    for (var i=0; i<6; i++)
      this.rButtons[i].setAttribute("disabled", status[i]);
    for (i=3; i<7; i++)
      this.rPopup[i].setAttribute("disabled", status[i-3]);
  },
  
  topBottomButtonStatusTest: function(selections) {
    for (var i=selections.length; --i > 0;)
      if (selections[i]-selections[i-1] != 1)
        return "false";
    
    return "true";
  },
  
  permissionSelected: function() {
    var selections = this.getTreeSelections();
    var buttonsStatus = [];
    
    if (selections[0] == 0) {
      if (selections.length == 1) buttonsStatus.push("true");
      else buttonsStatus.push(this.topBottomButtonStatusTest(selections));
      
      buttonsStatus.push("true");
    } else {
      buttonsStatus.push("false","false");
    }
    
    if (selections[selections.length-1]+1 == this.rTreeCh.childNodes.length) {
      buttonsStatus.push("true");
      
      if (selections.length == 1) buttonsStatus.push("true");
      else buttonsStatus.push(this.topBottomButtonStatusTest(selections));
    } else {
      buttonsStatus.push("false","false");
    }
    
    if (selections.length != 0) buttonsStatus.push("false");
    else buttonsStatus.push("true");
    
    this.buttonsDisabled(buttonsStatus);
  },

  removeFilter: function(all) {
    if (all) this.rTree.view.selection.selectAll();
    
    var selections = this.getTreeSelections();
    
    for (var s = selections.length-1; s >= 0; s--)
      this.rTreeCh.removeChild(this.rTreeCh.childNodes[selections[s]]);
    
    var bAll = this.rTreeCh.childNodes.length == 0 ? "true" : "false";
    this.buttonsDisabled([ "true","true","true","true","true",bAll ]);
  },
  
  filterSetPriority: function(prior) {
    var selections = this.getTreeSelections();
    var deletedItems = [];
    var i, iCount;
    
    switch (prior) {
      case "up":
        iCount = selections.length;
        for (i = 0; i < iCount; i++)
          this.rTreeCh.insertBefore(this.rTreeCh.childNodes[selections[i]],
                                    this.rTreeCh.childNodes[selections[i]-1]);
        break;
      case "down":
        for (i = selections.length-1; i >= 0; i--)
          this.rTreeCh.insertBefore(this.rTreeCh.childNodes[selections[i]],
                                    this.rTreeCh.childNodes[selections[i]+2]);
        break;
      case "top":
        for (i = selections.length-1; i >= 0; i--) {
          deletedItems.push(this.rTreeCh.childNodes[selections[i]]);
          this.rTreeCh.removeChild(this.rTreeCh.childNodes[selections[i]]);
        }
        
        iCount = deletedItems.length;
        
        for (i = 0; i < iCount; i++)
          this.rTreeCh.insertBefore(deletedItems[i], this.rTreeCh.childNodes[0]);
        
        break;
      
      case "bottom":
        for (i = selections.length-1; i >= 0; i--) {
          deletedItems.push(this.rTreeCh.childNodes[selections[i]]);
          this.rTreeCh.removeChild(this.rTreeCh.childNodes[selections[i]]);
        }
        
        for (i = deletedItems.length-1; i >= 0; i--)
          this.rTreeCh.appendChild(deletedItems[i]);
        
        break;
    }
    
    this.setTreeSelections(selections, prior);
  },

  setTreeSelections: function(selections, prior) {
    var range, select = this.rTree.view.selection;
    
    switch (prior) {
      case "up":
        for (var s = selections.length-1; s >= 0; s--) {
          range = selections[s]-1;
          select.rangedSelect(range, range, true);
        }
        break;
      
      case "down":
        for (var s = selections.length-1; s >= 0; s--) {
          range = selections[s]+1;
          select.rangedSelect(range, range, true);
        }
        break;
      
      case "top":
        range = selections.length-1;
        select.rangedSelect(0, range, true);
        break;
      
      case "bottom":
        range = this.rTreeCh.childNodes.length;
        select.rangedSelect(range-selections.length, range-1, true);
        break;
    }
  },
  
  /**
   * Patterns adding
   **/
  addFilter: function() {
    var filter = this.rAddFilter.value.replace(/\s*/g, "");
    var policy = 4 - this.rAddPolicy.selectedIndex;
    
    if (filter == "") return;
    
    var indx = 1 + this.getTreeSelections()[0];
    if (isNaN(indx)) indx = 1;
    
    this.treeAddItem([filter, policy], indx);
  },
  
  filterEdit: function(event, click) {
    if ((event.button == 0 && click == "dblclick") ||
        (event.button == 2 && click == "rclick"))
    {
      var row = {};
      
      var b = event.originalTarget.parentNode.treeBoxObject;
      b.getCellAt(event.clientX, event.clientY, row, {}, {});
      
      if (row.value == -1)
        return event.originalTarget.removeAttribute("context");
      
      switch (click) {
        case "dblclick":
          this.checkEvent("modify");
          break;
        
        case "rclick":
          var selections = this.getTreeSelections();
          
          var disable = selections.length != 1 ? true : false;
          this.rPopup[0].setAttribute("disabled", disable);
          this.rPopup[1].setAttribute("disabled", disable);
          
          event.originalTarget.setAttribute("context", "iloFiltersPopup");
          
          break;
      }
    }
  },

  getRowData: function() {
    var select = this.getTreeSelections();
    
    //~ alert("Please, give me a single row selection");
    if (select.length != 1) return;
    
    //~ return Array( filter, policy, row index )
    return [this.rTreeCh.childNodes[select[0]].childNodes[0].childNodes[1].getAttribute("label"),
            this.rTreeCh.childNodes[select[0]].childNodes[0].childNodes[2].getAttribute("label"),
            select[0]];
  }
};

window.addEventListener("load", function(){ILOpt.onLoad();}, false);